#!/usr/bin/perl -w

use strict;

use DBI;
use Data::Dumper;

# Database connection
my $db_host = 'localhost';
my $db_user = 'username';
my $db_pass = 'password';
my $db_name = 'database';

# Connect to the database
my $dbh = DBI->connect("dbi:mysql:database=$db_name;host=$db_host",$db_user,$db_pass)
	or die $DBI::errstr;

# Change the IDs of categories that you want to process.  In my 
# installation I have two categories: Entertainment with ID = 14 and
# Movies with ID = 15.
my $sth = $dbh->prepare('SELECT post_id FROM wp_post2cat WHERE category_id = 14 OR category_id = 15 GROUP BY post_id');
my $rv = $sth->execute() or die $sth->errstr;

while (my $data = $sth->fetchrow_hashref()) {
	my $post_id = $data->{'post_id'};

	my $sth2 = $dbh->prepare("SELECT post_title,post_content FROM wp_posts WHERE ID = $post_id");
	my $rv2  = $sth2->execute() or die $sth2->errstr;
	my $data2 = $sth2->fetchrow_hashref();

	my $title = $data2->{'post_title'};
	my $body  = $data2->{'post_content'};
	
	# This is how I want them to be.
	# <strong>My rating:</strong> 6.5 [rate 6.5]
	if ($body =~ m#<strong>My\s+rating:</strong>\s+\d{1,2}\.\d{1}\s+out\s+of\s+\d{2}#) {
		$body =~ s#(<strong>My\s+rating:</strong>\s+\d{1,2}\.\d{1})\s+out\s+of\s+10#$1#;
		print "Matched $post_id => $title ";
		$body =~ s#<strong>My\s+rating:</strong>\s+(\d{1,2})\.(\d{1})#<strong>My rating:</strong> $1.$2 [rate $1.$2]#;
		my $sth3 = $dbh->prepare(qq{UPDATE wp_posts SET post_content = ? WHERE ID = ?});
		my $rv3 = $sth3->execute($body,$post_id) or die $sth3->errstr;
		print "... Updated\n";
	}
}
